/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
/*

       This module manages the Signal libraries
  
 A Signal library is a graphical Signal file which may be loaded as a
 library or as a classical Signal file (the name of the file is suffixed by ".gpk").

 A Signal library is a module which has a list of declaration of  processes; 
 each process has an icon. The icon is contained in a file which name is the name
 of the sub-process followed by ".gif". For example, if the name of the
 process is "delay", the name of the file must be "delay.gif".

 When the user loads a library, all the icons are displayed in a window.
 When the user clicks on an icon and then on his canvas, the icon is
 displayed on it. If a call of a process of the library exists in the
 library, then this call is copied in the user program (the call may
 have ports, so the user has not have to create the ports); if there
 is not call, then a call is created and added in the user program.
*/ 

#include "pKio.h"
#include "classReferences.h"
#include "common_type.h"
#include "string_type.h"
#include "SUPERVISEUR_types.h" 
#include "graphicalTypes.h"
#include "typ_acces.h"
#include "const_i.h"
#include "const_gra_i.h"
#include "opersignal.h"
#include "string_api.h"
#include "message.h"
#include "tree_api.h"
#include "signal_tree.h"
#include "graphicalTrees.h"
#include "graphicTablesManager.h"
#include "builder.h"
#include "LiaisonSignalC2Java_g.h"
#include "biblio_m.c"
#include "biblio_g.h"
#include "biblio_g.c"
