/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */

package gui_dependent;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.File;
import java.lang.System;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JSplitPane;
import javax.swing.JToolBar;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.*;
import java.io.File;
import java.lang.System;
import java.util.Vector;
import common.PolychronyWindow;

public class PolychronyWindowDependent extends JFrame {
    protected boolean isEclipse = false;

    protected void setFrame(Frame awtFrame)
    {
    }

 /* Function is called on an exit menu choice or delete from the WM menu*/
   protected void Destroy() {
        dispose();
    } 

// PLG endPolychronyWindowConstructorDependent renamed assembleInTopWindow
    protected void assembleInTopWindow(JPanel globalMenuPanel, JSplitPane signalEditPanel ) {
        Container frame;

        frame = getContentPane();
        frame.setLayout(new BorderLayout());
        frame.add(globalMenuPanel, BorderLayout.NORTH);
        frame.add(signalEditPanel, BorderLayout.CENTER);
        validate();
        setContentPane(frame);
        pack();

    }

    protected void newWindowInEclipse(String numWindow)
    {
	
    }

    protected void CloseOperationDependent()
    {
	setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    }


    protected void  addWindowListenerDependent()
    {	
	// to close the window
	WindowListener closeWin = new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    PolychronyWindow source = (PolychronyWindow) e.getSource();
		    source.close_Pwindow();
		}
	    };
	addWindowListener(closeWin);
    }

    protected void setTitleDependent(String vtitle)
    {
        setTitle(vtitle);
    }

    /** Method called when the user clicks on the button "quit".
     */
    public boolean confirmPolychronyExit() {
	return true;
    }
}

