module InteSignalCompiler =
   type ntrees = external, ptrepstr = external; 
   type typeDCG = external; 
   constant typeDCG NILDCG = external; 
   type DCGLevel = enum (undefDCG, basicDCG, polyDCG, endoDCG, boolDCG, seqDCG, flatDCG); 
   process DCGBasic2DCGPoly =
        ( ? typeDCG gbasic;
          ! boolean ok; 
            typeDCG gpoly;
        )
        spec (| gbasic ^= ok
              | gpoly ^= [:ok]
              |)
   
   ; 
   process DCGPoly2DCGBool =
        ( ? typeDCG gpoly;
          ! boolean ok; 
            typeDCG gbool;
        )
        spec (| gpoly ^= ok
              | gbool ^= [:ok]
              |)
   
   ; 
   process DCGBool2DCGFlat =
        ( ? typeDCG gbool;
          ! boolean ok; 
            typeDCG gflat;
        )
        spec (| gbool ^= ok
              | gflat ^= [:ok]
              |)
   
   ; 
   process DCGBool2DCGSeq =
        ( ? typeDCG gbool;
          ! boolean ok; 
            typeDCG gseq;
        )
        spec (| gbool ^= ok
              | gseq ^= [:ok]
              |)
   
   ; 
   process Retiming =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process ClockCalcul =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process mkProfiling =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process BooleansEvents =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process InterfaceCalculus =
        ( ? typeDCG g; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| g ^= ok |)
   
   ; 
   process CycleDetection =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process Optimisations =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process transitiveClosure =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process GenSignal =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process GenC =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process GenCseparate =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process GenCPP =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process GenJAVA =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process GenSyndexCode =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process GenZ3z =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process ClockEnvBuilding =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process Pruning =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process trainsCalculus =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process Unifications =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process GenSignalAbs =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok;
        )
        spec (| igraph ^= ok |)
   
   ; 
   process BuildAbstraction =
        ( ? typeDCG igraph; 
            DCGLevel level;
          ! boolean ok; 
            typeDCG gbool;
        )
        spec (| igraph ^= ok
              | gbool ^= [:ok]
              |)
   
   ; 
   process END_OF_FUNCTIONALITY =
        ( ? boolean b;
        )
   
   ; 
   process PRE_COMP =
        ( ? ntrees tree; 
            integer typ_comp;
          ! ntrees tree_comp; 
            boolean err; 
            boolean ok;
        )
        spec (| tree ^= typ_comp ^= ok ^= tree_comp ^= err |)
   
   ; 
   process GRAPH_BUILDING =
        ( ? ntrees tree;
          ! typeDCG igraph; 
            boolean err_build;
        )
      (| (graph, err_build) := GRAPH_BUILD(tree)
       | igraph := graph when (not err_build)
       |)
      where 
      typeDCG graph;
      end
   ; 
   process mkInputTrains =
        ( ? typeDCG igraph;
          ! boolean ok; 
            typeDCG gb;
        )
      (| ok1 := ClockEnvBuilding(igraph, #DCG_poly)
       | ok2 := InterfaceCalculus(igraph when ok1, #DCG_poly)
       | (ok3, gb) := DCGPoly2DCGBool(igraph when ok2)
       | ok4 := CycleDetection(gb when ok3, #DCG_bool)
       | ok := trainsCalculus(gb when ok4, #DCG_bool)
       |)
      where 
      boolean ok1, ok2, ok3, ok4;
      end
   ; 
   process END_COMP =
        ( ? boolean B;
        )
   
   ; 
   process END_COMP_ERR =
        ( ? boolean B;
        )
   
   ; 
   process GRAPH_BUILD =
        ( ? ntrees tree_comp;
          ! typeDCG graph; 
            boolean err;
        )
        spec (| tree_comp ^= graph ^= err |)
   
   ; 
   process END_COMP_ARCHI =
        ( ? typeDCG igraph; 
            DCGLevel level;
        )
   
   ; 
   process END_COMP_ERR_ARCHI =
        ( ? boolean fini;
        )
   
   ; 
   process DCGPoly2DCGEndo =
        ( ? typeDCG gpoly;
          ! boolean ok; 
            typeDCG gendo;
        )
        spec (| gpoly ^= ok
              | gendo ^= [:ok]
              |)
   
   ; 
   process DCGEndo2DCGBool =
        ( ? typeDCG gendo;
          ! boolean ok; 
            typeDCG gbool;
        )
        spec (| gendo ^= ok
              | gbool ^= [:ok]
              |)
   
   ;
end %InteSignalCompiler%; 
