/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */

//  methods called from C++ to JAVA

EXTERN void C2Java_refresh(boolean hasChanged);
EXTERN void C2Java_drawPolyline(int x_points[],int y_points[],int nbPoints, int couleur, int epaisseur);
EXTERN  void C2Java_drawLine(int x_deb_pat,int y_deb_pat, int x_fin_pat, int y_fin_pat, int couleur, int epaisseur);
EXTERN void C2Java_drawPolygon(int xPoints[], int yPoints[], int nPoints, int couleur, int epaisseur) ;
EXTERN void C2Java_FillPolygon(int xPoints[], int yPoints[], int nPoints, int couleur, int epaisseur) ;
EXTERN void C2Java_drawRectangle(int x, int y, int w, int h, int couleur, int epaisseur);
EXTERN void C2Java_FillRectangle(int x, int y, int w, int h, int couleur);
EXTERN void C2Java_drawString(const char *chaine, int x, int y, int couleur,int typeFont);
EXTERN void C2Java_drawImage(const char *chaine, int x, int y);

EXTERN int C2Java_readMenuButton();
EXTERN void C2Java_razMenuButton();
EXTERN int C2Java_getMouseButton();
EXTERN boolean C2Java_isMouseButtonClicked();
EXTERN int C2Java_getX();
EXTERN int C2Java_getY();
EXTERN void C2Java_setMoveMouseEvent();
EXTERN void C2Java_resetMoveMouseEvent();
EXTERN void C2Java_textHide(text_win_type w);
EXTERN void C2Java_textShow(text_win_type w);
EXTERN int C2Java_getTextColumns(text_win_type w);
EXTERN void C2Java_textAppend(text_win_type w, const char *text);
EXTERN void C2Java_setTitle(text_win_type w, const char *text);
EXTERN void C2Java_showNamePort(char *text);
EXTERN void C2Java_showPortHide();
EXTERN typChoice C2Java_getUserChoice();
EXTERN void C2Java_getIdentsForReplace_old(ptrepstr *ident1, ptrepstr *ident2); // TO BE REMOVED.
EXTERN void C2Java_getIdentsForReplace (ptident * ident1, ptident * ident2);
EXTERN char * C2Java_getText(text_win_type w);
EXTERN void C2Java_resetText(text_win_type w);
EXTERN text_win_type C2Java_getLastActiveTextWin();
EXTERN boolean C2Java_getNamesState();
EXTERN boolean C2Java_getDetailState();
EXTERN void C2Java_displayFont();
EXTERN int C2Java_getSizeFontH(int type);
EXTERN int C2Java_getSizeFontL(int type);
EXTERN char* C2Java_getUserCurrentPath();
EXTERN int C2Java_getFileNameFromBrowser(boolean isGraphic, boolean OpenOp, char **fileName);
EXTERN void C2Java_appendNewJNode(const char *nom, int noProc, boolean setInAtEnd);
// EXTERN void C2Java_insertObject(char *nom, int noProc, int rang);
EXTERN void C2Java_deleteSelectedNode();
EXTERN void C2Java_upTempSelectedNode();
EXTERN void C2Java_SetCurrentTree(int iBox);
EXTERN void C2Java_initSelectedNode(boolean afterCompil);
EXTERN void C2Java_deleteSelectedNode();
EXTERN void C2Java_quitApplication();
EXTERN void C2Java_displayError(int no);
EXTERN void C2Java_displayParsingError(char* str);
EXTERN void C2Java_displayConfirm(int action);
EXTERN void C2Java_displayCurrentAction(int action);
EXTERN void C2Java_displayCompilerFunct();
EXTERN void C2Java_displayCompilerDiag();
EXTERN void C2Java_displayAutoCompilerFunct();
EXTERN int C2Java_getCompilerFunct();
EXTERN void C2Java_setColorCompilerFunct(int func, int col);
EXTERN void C2Java_compilerWinClose();
EXTERN void C2Java_PostscriptPrint();
EXTERN void C2Java_helpShow();
EXTERN void C2Java_createLibBar( char* filename, ntrees libRoot, char* filenamews, char* libname);
EXTERN ntrees C2Java_getRefLib();
EXTERN int C2Java_getIconIndex();
EXTERN int C2Java_getHightIcon();
EXTERN int C2Java_getLenghtIcon();
EXTERN boolean C2Java_isLoadedLibrary(char *filename);
EXTERN void C2Java_removeSelectedLib(char* filename);
EXTERN char* C2Java_getSelectedFilenameLibrary();
EXTERN int C2Java_getIndexLibrary(char * fn);
EXTERN void C2Java_install_library(ntrees lib, int vindex);
