/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */

#define TBM 20 /* taille max du buffer de mapping */

typedef struct 
{
  int no_seg, no_port1, no_port2;
}ty_map_lien;
  

class builder
{

#include "commonBuilder_m.h"
#include "boxBuilder_m.h"
#include "linkBuilder_m.h"
#include "mappingBuilder_m.h"
#include "commonBuilder_g.h"
#include "boxBuilder_g.h"
#include "linkBuilder_g.h"
#include "mappingBuilder_g.h"

private :
  static typ_tampon the_graphClipBoard;

  ptGraphicTablesManager the_graphicTablesManager;
  ptGraphicTrees the_graphicalTrees;
  ptMessage the_messageTool;

  ptCurrentObjectsManager pCurObjManager;
  ptSignalDisplaying pDisplay;
  ptDrawing pDraw;
  ptRoutor pRoutor;
  ptUndo pUndo;

  int tours, premiertour, x_pred, y_pred, x_coin_g, y_coin_g, pt_dep, 
    pt_arr, nbcoord, mask, sens, obj, obj_desig, larg, haute, 
    y1_reticule, cpt_ports, y_min, y_max, ou, pas_g, x1_reticule, x_deb, 
    y_deb, x_fin, y_fin, x_stop, y_stop, x_bouge, y_bouge, m_t_bte, sens_dep, 
    bte, depart, h_bte, bte_a_text;

  typcoord mil, tcoord[maxcoord], bcoord[2], bouge, tcoord_ports[maxports];
  objet_type typ_obj, typ_obj1, typ_obj_dupl;
  ntrees p_gra, pppppppppp, port;
  db_reel scale; 
  boolean porte, loc, modtail, fini;
  ntrees arb_map;
  int map_buffer[TBM]; /* buffer contenant les numeros des boites dans 
			  lesquelles on fait du mapping */
  
  ty_map_lien l_map; /* structure permettant de stocker les informations 
		       necessaires pour mapper de lien : 
		       1 numero de segment et 2 numeros de ports */

  ntrees idente, idents;/* arbre liste des identificateurs de ports */
  ptrepstr currentPortName; /* used when the user gives the name of the ports after the 
			    analysis of a Signal expression */
  int raction; /* utilisee dans depl_seg_routage uniquement, pour savoir s'il faut 
			 lancer le routage concernant un port ou non */ 
  typcoord coord_bte_engl; // coordonnees du point haut_gauche de la bte engl
};
