/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */
#define oplien 12 
#define opabs 18
#define opord 19
#define opordBin 19
#define opordList 19
#define opdesign 22
#define opdesignList 22
#define opport 32

#define oprect 15 /* nmakebinary(oprect */
#define oppave 16 /* nmakebinary(oppave */
#define opcoord 17 /* nmakebinary(opcoord */
#define gpkOp_segm 29 /* nmakebinary(gpkOp_segm */
#define opseg 20 /* nmakebinary(opseg */
#define opdata 23 /* nmakebinary(opdata */
#define opextm 33 /* nmakebinary(opextm */
#define opencaps 35 /* nmakebinary(opencaps */

#define opschema 10 /* nmaketernary(opschema */
#define gpkOp_bte 11 /* nmaketernary(gpkOp_bte */

#define gpkOp_porte 13 /* input port nmakequaternary(gpkOp_porte */
#define gpkOp_ports 14 /* output port nmakequaternary( */
#define opchemin 31 /* nmakequaternary(opchemin, s1, s2, s3, s4); */

#define oplports 24 /* LL_make_lports_emptyList() */
#define oppolyline 25 /*  LL_make_polyline_emptyList() */
#define oplsegs 27 /* LL_make_lsegs_emptyList() */
#define gpkOp_chemins 30 /* LL_make_chemins_emptyList() */
#define oplnports 34 /* LL_make_lnports_emptyList() */

#define opextrem 21 /* UNUSED: useless ? */
/* regarder createCoordTree oprect, oppave, opseg  */ 

#define LL_make_lien_atom(VALARG) natomint(oplien, VALARG)
#define LL_make_abs_atom(VALARG) natomint(opabs, VALARG)
#define LL_make_ord_atom(VALARG) natomint(opord, VALARG)
#define LL_make_design_atom(VALARG) natomint(opdesign, VALARG)
#define LL_make_port_atom(VALARG) natomint(opport, VALARG)

#define LL_make_ordBin(ARG1, ARG2) nmakebinary(opordBin, ARG1, ARG2)
#define LL_make_rect(ARG1, ARG2) nmakebinary(oprect, ARG1, ARG2)
#define LL_make_pave(ARG1, ARG2) nmakebinary(oppave, ARG1, ARG2)
#define LL_make_coord(ARG1, ARG2) nmakebinary(opcoord, ARG1, ARG2)
#define LL_make_segm(ARG1, ARG2) nmakebinary(gpkOp_segm, ARG1, ARG2)
#define LL_make_seg(ARG1, ARG2) nmakebinary(opseg, ARG1, ARG2)
#define LL_make_data(ARG1, ARG2) nmakebinary(opdata, ARG1, ARG2)
#define LL_make_extm(ARG1, ARG2) nmakebinary(opextm, ARG1, ARG2)
#define LL_make_encaps(ARG1, ARG2) nmakebinary(opencaps, ARG1, ARG2)

#define LL_make_schema(ARG1, ARG2, ARG3) nmaketernary(opschema, ARG1, ARG2, ARG3)
#define LL_make_bte(ARG1, ARG2, ARG3) nmaketernary(gpkOp_bte, ARG1, ARG2, ARG3)

#define LL_make_porte(ARG1, ARG2, ARG3, ARG4) nmakequaternary(gpkOp_porte, ARG1, ARG2, ARG3, ARG4)
#define LL_make_ports(ARG1, ARG2, ARG3, ARG4) nmakequaternary(gpkOp_ports, ARG1, ARG2, ARG3, ARG4)
#define LL_make_chemin(ARG1, ARG2, ARG3, ARG4) nmakequaternary(opchemin, ARG1, ARG2, ARG3, ARG4)


#define LL_make_schema(ARG1, ARG2, ARG3) nmaketernary(opschema, ARG1, ARG2, ARG3)
#define LL_make_bte(ARG1, ARG2, ARG3) nmaketernary(gpkOp_bte, ARG1, ARG2, ARG3)

#define LL_make_ord_emptyList() nmakemptylist(opordList)
#define LL_make_design_emptyList() nmakemptylist(opdesignList)

#define LL_make_lports_emptyList() nmakemptylist(oplports)
#define LL_make_lports_list(ARG) nmakelist(oplports, ARG)
#define LL_make_polyline_emptyList() nmakemptylist(oppolyline)
#define LL_make_lsegs_emptyList() nmakemptylist(oplsegs)
#define LL_make_chemins_emptyList() nmakemptylist(gpkOp_chemins)
#define LL_make_chemins_list(ARG) nmakelist(gpkOp_chemins, ARG)
#define LL_make_lnports_emptyList() nmakemptylist(oplnports)

