/*
   Authors: Loic Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr

   This file is part of Polychrony Signal GUI (http://www.irisa.fr/espresso/polychrony).

   Polychrony Signal GUI is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal GUI is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal GUI; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA.
 */

#define dist_max 1000

typedef typcoord ty_halo[2];
 
typedef long int graphObj_type;
#define GRAPHOBJ_TYPEMAX LONG_MAX

typedef struct acces
{	graphObj_type graphObj;
	ntrees elem_gra;
        typcoord ext1_halo,ext2_halo;
	struct acces *suiv_d;
	struct acces *pred_d;    
	struct acces *suivant;
}acces_gra;

typedef struct seg
{
        int id;
        int direc;
        int port_;
        ntrees arb_seg;
        typcoord ext1_halo,ext2_halo;
        struct seg *suiv_d;
        struct seg *pred_d;
        struct seg *suivant;
}acces_seg;

typedef acces_seg *pt_seg;

typedef struct
{	ntrees arb;
	objet_type typ;
	boolean opproc;
} typ_tampon;

